# coding: utf-8

"""
    VMware Aria Automation Assembler / Service Broker API

    A multi-cloud API for Cloud Automation Services  The APIs that list collections of resources also support OData like implementation. Below query params can be used across Assembler / Service Broker entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/catalog/api/items?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/catalog/api/items?$top=10&$skip=2```  3. `page` and `size` - page used in conjunction with `$size` helps in pagination of resources.      ```/catalog/api/items?page=0&size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /catalog/api/items?$filter=startswith(name, 'Act')     /catalog/api/items?$filter=toupper(name) eq 'ACTIVATE'     /catalog/api/items?$filter=substringof('renameVM', name)     /catalog/api/items?$filter=name eq 'ABCD'  # noqa: E501

    OpenAPI spec version: 2020-08-25
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PageCatalogItemTypeContent(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'base_uri': 'str',
        'created_by': 'str',
        'created_at': 'datetime',
        'config_schema': 'DeploymentapiresourcesresourceIdactionsSchema',
        'icon_id': 'str'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'base_uri': 'baseUri',
        'created_by': 'createdBy',
        'created_at': 'createdAt',
        'config_schema': 'configSchema',
        'icon_id': 'iconId'
    }

    def __init__(self, id=None, name=None, base_uri=None, created_by=None, created_at=None, config_schema=None, icon_id=None):  # noqa: E501
        """PageCatalogItemTypeContent - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._base_uri = None
        self._created_by = None
        self._created_at = None
        self._config_schema = None
        self._icon_id = None
        self.discriminator = None
        if id is not None:
            self.id = id
        self.name = name
        if base_uri is not None:
            self.base_uri = base_uri
        if created_by is not None:
            self.created_by = created_by
        if created_at is not None:
            self.created_at = created_at
        if config_schema is not None:
            self.config_schema = config_schema
        if icon_id is not None:
            self.icon_id = icon_id

    @property
    def id(self):
        """Gets the id of this PageCatalogItemTypeContent.  # noqa: E501

        Human-readable unique ID containing only lowercase letters and periods, neither starting nor ending with a period, and never having two consecutive periods  # noqa: E501

        :return: The id of this PageCatalogItemTypeContent.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PageCatalogItemTypeContent.

        Human-readable unique ID containing only lowercase letters and periods, neither starting nor ending with a period, and never having two consecutive periods  # noqa: E501

        :param id: The id of this PageCatalogItemTypeContent.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this PageCatalogItemTypeContent.  # noqa: E501

        Unique Catalog Item Type name  # noqa: E501

        :return: The name of this PageCatalogItemTypeContent.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PageCatalogItemTypeContent.

        Unique Catalog Item Type name  # noqa: E501

        :param name: The name of this PageCatalogItemTypeContent.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def base_uri(self):
        """Gets the base_uri of this PageCatalogItemTypeContent.  # noqa: E501

        Base callback URI for import operations  # noqa: E501

        :return: The base_uri of this PageCatalogItemTypeContent.  # noqa: E501
        :rtype: str
        """
        return self._base_uri

    @base_uri.setter
    def base_uri(self, base_uri):
        """Sets the base_uri of this PageCatalogItemTypeContent.

        Base callback URI for import operations  # noqa: E501

        :param base_uri: The base_uri of this PageCatalogItemTypeContent.  # noqa: E501
        :type: str
        """

        self._base_uri = base_uri

    @property
    def created_by(self):
        """Gets the created_by of this PageCatalogItemTypeContent.  # noqa: E501

        Service that created this type  # noqa: E501

        :return: The created_by of this PageCatalogItemTypeContent.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this PageCatalogItemTypeContent.

        Service that created this type  # noqa: E501

        :param created_by: The created_by of this PageCatalogItemTypeContent.  # noqa: E501
        :type: str
        """

        self._created_by = created_by

    @property
    def created_at(self):
        """Gets the created_at of this PageCatalogItemTypeContent.  # noqa: E501

        Creation time  # noqa: E501

        :return: The created_at of this PageCatalogItemTypeContent.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this PageCatalogItemTypeContent.

        Creation time  # noqa: E501

        :param created_at: The created_at of this PageCatalogItemTypeContent.  # noqa: E501
        :type: datetime
        """

        self._created_at = created_at

    @property
    def config_schema(self):
        """Gets the config_schema of this PageCatalogItemTypeContent.  # noqa: E501


        :return: The config_schema of this PageCatalogItemTypeContent.  # noqa: E501
        :rtype: DeploymentapiresourcesresourceIdactionsSchema
        """
        return self._config_schema

    @config_schema.setter
    def config_schema(self, config_schema):
        """Sets the config_schema of this PageCatalogItemTypeContent.


        :param config_schema: The config_schema of this PageCatalogItemTypeContent.  # noqa: E501
        :type: DeploymentapiresourcesresourceIdactionsSchema
        """

        self._config_schema = config_schema

    @property
    def icon_id(self):
        """Gets the icon_id of this PageCatalogItemTypeContent.  # noqa: E501

        Default Icon Id  # noqa: E501

        :return: The icon_id of this PageCatalogItemTypeContent.  # noqa: E501
        :rtype: str
        """
        return self._icon_id

    @icon_id.setter
    def icon_id(self, icon_id):
        """Sets the icon_id of this PageCatalogItemTypeContent.

        Default Icon Id  # noqa: E501

        :param icon_id: The icon_id of this PageCatalogItemTypeContent.  # noqa: E501
        :type: str
        """

        self._icon_id = icon_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PageCatalogItemTypeContent, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PageCatalogItemTypeContent):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
